ALSA: pcm: Unexport snd_pcm_sgbuf_ops_page
[linux-2.6-block.git] / scripts / link-vmlinux.sh
CommitLineData
1f2bfbd0 1#!/bin/sh
b2441318 2# SPDX-License-Identifier: GPL-2.0
1f2bfbd0
SR
3#
4# link vmlinux
5#
d151e971
MY
6# vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_OBJS) and
7# $(KBUILD_VMLINUX_LIBS). Most are built-in.a files from top-level directories
8# in the kernel tree, others are specified in arch/$(ARCH)/Makefile.
9# $(KBUILD_VMLINUX_LIBS) are archives which are linked conditionally
10# (not within --whole-archive), and do not require symbol indexes added.
1f2bfbd0
SR
11#
12# vmlinux
13# ^
14# |
d151e971
MY
15# +--< $(KBUILD_VMLINUX_OBJS)
16# | +--< init/built-in.a drivers/built-in.a mm/built-in.a + more
1f2bfbd0 17# |
3a166fc2
NP
18# +--< $(KBUILD_VMLINUX_LIBS)
19# | +--< lib/lib.a + more
20# |
1f2bfbd0
SR
21# +-< ${kallsymso} (see description in KALLSYMS section)
22#
23# vmlinux version (uname -v) cannot be updated during normal
24# descending-into-subdirs phase since we do not yet know if we need to
25# update vmlinux.
26# Therefore this step is delayed until just before final link of vmlinux.
27#
28# System.map is generated to document addresses of all kernel symbols
29
30# Error out on error
31set -e
32
33# Nice output in kbuild format
34# Will be supressed by "make -s"
35info()
36{
37 if [ "${quiet}" != "silent_" ]; then
e83b9f55 38 printf " %-7s %s\n" "${1}" "${2}"
1f2bfbd0
SR
39 fi
40}
41
42# Link of vmlinux.o used for section mismatch analysis
43# ${1} output file
44modpost_link()
45{
a5967db9
SR
46 local objects
47
6358d6e8 48 objects="--whole-archive \
d151e971 49 ${KBUILD_VMLINUX_OBJS} \
6358d6e8
NP
50 --no-whole-archive \
51 --start-group \
52 ${KBUILD_VMLINUX_LIBS} \
53 --end-group"
54
d503ac53 55 ${LD} ${KBUILD_LDFLAGS} -r -o ${1} ${objects}
1f2bfbd0
SR
56}
57
58# Link of vmlinux
341dfcf8 59# ${1} - output file
618916a4 60# ${2}, ${3}, ... - optional extra .o files
1f2bfbd0
SR
61vmlinux_link()
62{
63 local lds="${objtree}/${KBUILD_LDS}"
618916a4 64 local output=${1}
a5967db9 65 local objects
1f2bfbd0 66
d7b0827f
LT
67 info LD ${output}
68
618916a4
AN
69 # skip output file argument
70 shift
71
1f2bfbd0 72 if [ "${SRCARCH}" != "um" ]; then
6358d6e8 73 objects="--whole-archive \
d151e971 74 ${KBUILD_VMLINUX_OBJS} \
6358d6e8
NP
75 --no-whole-archive \
76 --start-group \
77 ${KBUILD_VMLINUX_LIBS} \
78 --end-group \
618916a4 79 ${@}"
a5967db9 80
618916a4
AN
81 ${LD} ${KBUILD_LDFLAGS} ${LDFLAGS_vmlinux} \
82 -o ${output} \
a5967db9 83 -T ${lds} ${objects}
1f2bfbd0 84 else
6358d6e8 85 objects="-Wl,--whole-archive \
d151e971 86 ${KBUILD_VMLINUX_OBJS} \
6358d6e8
NP
87 -Wl,--no-whole-archive \
88 -Wl,--start-group \
89 ${KBUILD_VMLINUX_LIBS} \
90 -Wl,--end-group \
618916a4 91 ${@}"
a5967db9 92
618916a4
AN
93 ${CC} ${CFLAGS_vmlinux} \
94 -o ${output} \
6358d6e8
NP
95 -Wl,-T,${lds} \
96 ${objects} \
a5967db9 97 -lutil -lrt -lpthread
1f2bfbd0
SR
98 rm -f linux
99 fi
100}
101
e83b9f55 102# generate .BTF typeinfo from DWARF debuginfo
341dfcf8
AN
103# ${1} - vmlinux image
104# ${2} - file to dump raw BTF data into
e83b9f55
AN
105gen_btf()
106{
341dfcf8
AN
107 local pahole_ver
108 local bin_arch
e83b9f55 109
581b31c3
AN
110 if ! [ -x "$(command -v ${PAHOLE})" ]; then
111 info "BTF" "${1}: pahole (${PAHOLE}) is not available"
341dfcf8 112 return 1
581b31c3
AN
113 fi
114
e83b9f55
AN
115 pahole_ver=$(${PAHOLE} --version | sed -E 's/v([0-9]+)\.([0-9]+)/\1\2/')
116 if [ "${pahole_ver}" -lt "113" ]; then
117 info "BTF" "${1}: pahole version $(${PAHOLE} --version) is too old, need at least v1.13"
341dfcf8 118 return 1
e83b9f55
AN
119 fi
120
341dfcf8
AN
121 info "BTF" ${2}
122 vmlinux_link ${1}
e83b9f55 123 LLVM_OBJCOPY=${OBJCOPY} ${PAHOLE} -J ${1}
341dfcf8
AN
124
125 # dump .BTF section into raw binary file to link with final vmlinux
fdf37037 126 bin_arch=$(LANG=C ${OBJDUMP} -f ${1} | grep architecture | \
341dfcf8 127 cut -d, -f1 | cut -d' ' -f2)
fdf37037
IL
128 bin_format=$(LANG=C ${OBJDUMP} -f ${1} | grep 'file format' | \
129 awk '{print $4}')
7fd78568 130 ${OBJCOPY} --dump-section .BTF=.btf.vmlinux.bin ${1} 2>/dev/null
fdf37037 131 ${OBJCOPY} -I binary -O ${bin_format} -B ${bin_arch} \
7fd78568 132 --rename-section .data=.BTF .btf.vmlinux.bin ${2}
e83b9f55 133}
1f2bfbd0
SR
134
135# Create ${2} .o file with all symbols from the ${1} object file
136kallsyms()
137{
138 info KSYM ${2}
139 local kallsymopt;
140
141 if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then
6895f97e 142 kallsymopt="${kallsymopt} --all-symbols"
1f2bfbd0
SR
143 fi
144
4d5d5664 145 if [ -n "${CONFIG_KALLSYMS_ABSOLUTE_PERCPU}" ]; then
c6bda7c9
RR
146 kallsymopt="${kallsymopt} --absolute-percpu"
147 fi
148
2213e9a6
AB
149 if [ -n "${CONFIG_KALLSYMS_BASE_RELATIVE}" ]; then
150 kallsymopt="${kallsymopt} --base-relative"
151 fi
152
00e6c28c
SR
153 local aflags="${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \
154 ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS}"
1f2bfbd0 155
a0439342
AB
156 local afile="`basename ${2} .o`.S"
157
158 ${NM} -n ${1} | scripts/kallsyms ${kallsymopt} > ${afile}
159 ${CC} ${aflags} -c -o ${2} ${afile}
1f2bfbd0
SR
160}
161
8959e392
KC
162# Perform one step in kallsyms generation, including temporary linking of
163# vmlinux.
164kallsyms_step()
165{
166 kallsymso_prev=${kallsymso}
167 kallsymso=.tmp_kallsyms${1}.o
168 kallsyms_vmlinux=.tmp_vmlinux${1}
169
d7b0827f 170 vmlinux_link ${kallsyms_vmlinux} "${kallsymso_prev}" ${btf_vmlinux_bin_o}
8959e392
KC
171 kallsyms ${kallsyms_vmlinux} ${kallsymso}
172}
173
1f2bfbd0
SR
174# Create map file with all symbols from ${1}
175# See mksymap for additional details
176mksysmap()
177{
178 ${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
179}
180
1347a2ce
LT
181sortextable()
182{
183 ${objtree}/scripts/sortextable ${1}
184}
185
1f2bfbd0 186# Delete output files in case of error
1f2bfbd0
SR
187cleanup()
188{
341dfcf8 189 rm -f .btf.*
1f2bfbd0
SR
190 rm -f .tmp_System.map
191 rm -f .tmp_kallsyms*
1f2bfbd0
SR
192 rm -f .tmp_vmlinux*
193 rm -f System.map
194 rm -f vmlinux
195 rm -f vmlinux.o
196}
197
ab160dbb
SB
198on_exit()
199{
200 if [ $? -ne 0 ]; then
201 cleanup
202 fi
203}
204trap on_exit EXIT
205
206on_signals()
207{
208 exit 1
209}
210trap on_signals HUP INT QUIT TERM
211
1f2bfbd0
SR
212#
213#
214# Use "make V=1" to debug this script
215case "${KBUILD_VERBOSE}" in
216*1*)
217 set -x
218 ;;
219esac
220
221if [ "$1" = "clean" ]; then
222 cleanup
223 exit 0
224fi
225
226# We need access to CONFIG_ symbols
94cf8acc 227. include/config/auto.conf
1f2bfbd0 228
1f2bfbd0
SR
229# Update version
230info GEN .version
278ae604
MY
231if [ -r .version ]; then
232 VERSION=$(expr 0$(cat .version) + 1)
233 echo $VERSION > .version
1f2bfbd0 234else
278ae604
MY
235 rm -f .version
236 echo 1 > .version
1f2bfbd0
SR
237fi;
238
239# final build of init/
a7b151ff 240${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init
1f2bfbd0 241
abac4c89
NP
242#link vmlinux.o
243info LD vmlinux.o
244modpost_link vmlinux.o
245
246# modpost vmlinux.o to check for section mismatches
a721588d 247${MAKE} -f "${srctree}/scripts/Makefile.modpost" MODPOST_VMLINUX=1
abac4c89 248
898490c0
AG
249info MODINFO modules.builtin.modinfo
250${OBJCOPY} -j .modinfo -O binary vmlinux.o modules.builtin.modinfo
251
7fd78568 252btf_vmlinux_bin_o=""
341dfcf8 253if [ -n "${CONFIG_DEBUG_INFO_BTF}" ]; then
7fd78568
AN
254 if gen_btf .tmp_vmlinux.btf .btf.vmlinux.bin.o ; then
255 btf_vmlinux_bin_o=.btf.vmlinux.bin.o
341dfcf8
AN
256 fi
257fi
258
1f2bfbd0 259kallsymso=""
8959e392 260kallsymso_prev=""
1f2bfbd0
SR
261kallsyms_vmlinux=""
262if [ -n "${CONFIG_KALLSYMS}" ]; then
263
264 # kallsyms support
265 # Generate section listing all symbols and add it into vmlinux
266 # It's a three step process:
267 # 1) Link .tmp_vmlinux1 so it has all symbols and sections,
268 # but __kallsyms is empty.
269 # Running kallsyms on that gives us .tmp_kallsyms1.o with
270 # the right size
271 # 2) Link .tmp_vmlinux2 so it now has a __kallsyms section of
272 # the right size, but due to the added section, some
273 # addresses have shifted.
274 # From here, we generate a correct .tmp_kallsyms2.o
7e2b37c9
NP
275 # 3) That link may have expanded the kernel image enough that
276 # more linker branch stubs / trampolines had to be added, which
277 # introduces new names, which further expands kallsyms. Do another
278 # pass if that is the case. In theory it's possible this results
279 # in even more stubs, but unlikely.
280 # KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
281 # other bugs.
282 # 4) The correct ${kallsymso} is linked into the final vmlinux.
1f2bfbd0
SR
283 #
284 # a) Verify that the System.map from vmlinux matches the map from
285 # ${kallsymso}.
286
8959e392
KC
287 kallsyms_step 1
288 kallsyms_step 2
1f2bfbd0 289
7e2b37c9 290 # step 3
8959e392
KC
291 size1=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso_prev})
292 size2=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso})
7e2b37c9
NP
293
294 if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
8959e392 295 kallsyms_step 3
1f2bfbd0
SR
296 fi
297fi
298
d7b0827f 299vmlinux_link vmlinux "${kallsymso}" ${btf_vmlinux_bin_o}
e83b9f55 300
1347a2ce
LT
301if [ -n "${CONFIG_BUILDTIME_EXTABLE_SORT}" ]; then
302 info SORTEX vmlinux
303 sortextable vmlinux
304fi
305
1f2bfbd0
SR
306info SYSMAP System.map
307mksysmap vmlinux System.map
308
309# step a (see comment above)
310if [ -n "${CONFIG_KALLSYMS}" ]; then
311 mksysmap ${kallsyms_vmlinux} .tmp_System.map
312
313 if ! cmp -s System.map .tmp_System.map; then
5369f550 314 echo >&2 Inconsistent kallsyms data
367e43c5 315 echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
1f2bfbd0
SR
316 exit 1
317 fi
318fi